Index: squid/src/helper.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/helper.c,v
retrieving revision 1.1.1.3.24.1
retrieving revision 1.1.1.3.24.1.2.1
diff -u -r1.1.1.3.24.1 -r1.1.1.3.24.1.2.1
--- squid/src/helper.c	6 Jan 2001 12:40:14 -0000	1.1.1.3.24.1
+++ squid/src/helper.c	27 Aug 2001 21:48:21 -0000	1.1.1.3.24.1.2.1
@@ -1,5 +1,6 @@
 #ifndef HELPER_C
 #define HELPER_C
+
 #include "squid.h"
 
 #define HELPER_MAX_ARGS 64
@@ -17,7 +18,6 @@
 void
 helperOpenServers(helper * hlp)
 {
-#ifndef _SQUID_MSWIN_
     char *s;
     char *progname;
     char *shortname;
@@ -31,6 +31,11 @@
     int rfd;
     int wfd;
     wordlist *w;
+#ifdef _SQUID_MSWIN_
+    HANDLE hIpc;
+    pid_t pid;
+#endif
+
     if (hlp->cmdline == NULL)
 	return;
     progname = hlp->cmdline->key;
@@ -50,12 +55,11 @@
     for (k = 0; k < hlp->n_to_start; k++) {
 	getCurrentTime();
 	rfd = wfd = -1;
-	x = ipcCreate(hlp->ipc_type,
-	    progname,
-	    args,
-	    shortname,
-	    &rfd,
-	    &wfd);
+	x = ipcCreate(hlp->ipc_type, progname, args, shortname, &rfd, &wfd
+#ifdef _SQUID_MSWIN_
+	    , &hIpc, &pid
+#endif
+	    );
 	if (x < 0) {
 	    debug(29, 1) ("WARNING: Cannot run '%s' process.\n", progname);
 	    continue;
@@ -71,15 +75,21 @@
 	srv->buf_sz = 8192;
 	srv->offset = 0;
 	srv->parent = hlp;
+#ifdef _SQUID_MSWIN_
+	srv->hIpc = hIpc;
+	srv->pid = pid;
+#endif
 	cbdataLock(hlp);	/* lock because of the parent backlink */
 	dlinkAddTail(srv, &srv->link, &hlp->servers);
 	if (rfd == wfd) {
 	    snprintf(fd_note_buf, FD_DESC_SZ, "%s #%d", shortname, k + 1);
 	    fd_note(rfd, fd_note_buf);
 	} else {
-	    snprintf(fd_note_buf, FD_DESC_SZ, "reading %s #%d", shortname, k + 1);
+	    snprintf(fd_note_buf, FD_DESC_SZ, "reading %s #%d", shortname,
+		k + 1);
 	    fd_note(rfd, fd_note_buf);
-	    snprintf(fd_note_buf, FD_DESC_SZ, "writing %s #%d", shortname, k + 1);
+	    snprintf(fd_note_buf, FD_DESC_SZ, "writing %s #%d", shortname,
+		k + 1);
 	    fd_note(wfd, fd_note_buf);
 	}
 	commSetNonBlocking(rfd);
@@ -90,7 +100,6 @@
     safe_free(shortname);
     safe_free(procname);
     helperKickQueue(hlp);
-#endif 
 }
 
 void
@@ -121,35 +130,25 @@
     double tt;
     storeAppendPrintf(sentry, "number running: %d of %d\n",
 	hlp->n_running, hlp->n_to_start);
-    storeAppendPrintf(sentry, "requests sent: %d\n",
-	hlp->stats.requests);
-    storeAppendPrintf(sentry, "replies received: %d\n",
-	hlp->stats.replies);
-    storeAppendPrintf(sentry, "queue length: %d\n",
-	hlp->stats.queue_size);
+    storeAppendPrintf(sentry, "requests sent: %d\n", hlp->stats.requests);
+    storeAppendPrintf(sentry, "replies received: %d\n", hlp->stats.replies);
+    storeAppendPrintf(sentry, "queue length: %d\n", hlp->stats.queue_size);
     storeAppendPrintf(sentry, "avg service time: %d msec\n",
 	hlp->stats.avg_svc_time);
     storeAppendPrintf(sentry, "\n");
     storeAppendPrintf(sentry, "%7s\t%7s\t%11s\t%s\t%7s\t%7s\n",
-	"#",
-	"FD",
-	"# Requests",
-	"Flags",
-	"Time",
-	"Offset");
+	"#", "FD", "# Requests", "Flags", "Time", "Offset");
     for (link = hlp->servers.head; link; link = link->next) {
 	srv = link->data;
 	tt = 0.001 * tvSubMsec(srv->dispatch_time, current_time);
-	storeAppendPrintf(sentry, "%7d\t%7d\t%11d\t%c%c%c%c\t%7.3f\t%7d\n",
-	    srv->index + 1,
-	    srv->rfd,
+	storeAppendPrintf(sentry, "%7d\t%7d\t%11ld\t%c%c%c%c\t%7.3f\t%7d\n",
+	    srv->index + 1, srv->rfd,
 	    srv->stats.uses,
 	    srv->flags.alive ? 'A' : ' ',
 	    srv->flags.busy ? 'B' : ' ',
 	    srv->flags.closing ? 'C' : ' ',
 	    srv->flags.shutdown ? 'S' : ' ',
-	    tt < 0.0 ? 0.0 : tt,
-	    (int) srv->offset);
+	    tt < 0.0 ? 0.0 : tt, (int) srv->offset);
     }
     storeAppendPrintf(sentry, "\nFlags key:\n\n");
     storeAppendPrintf(sentry, "   A = ALIVE\n");
@@ -163,6 +162,11 @@
 {
     dlink_node *link = hlp->servers.head;
     helper_server *srv;
+#ifdef _SQUID_MSWIN_
+    HANDLE hIpc;
+    pid_t pid;
+    int no;
+#endif
     while (link) {
 	srv = link->data;
 	link = link->next;
@@ -183,7 +187,24 @@
 	    continue;
 	}
 	srv->flags.closing = 1;
+#ifdef _SQUID_MSWIN_
+	hIpc = srv->hIpc;
+	pid = srv->pid;
+	no = srv->index + 1;
+	shutdown(srv->rfd, SD_BOTH);
+#endif
 	comm_close(srv->rfd);
+#ifdef _SQUID_MSWIN_
+	if (hIpc) {
+	    if (WaitForSingleObject(hIpc, 5000) != WAIT_OBJECT_0) {
+		getCurrentTime();
+		debug(34, 1) ("helperShutdown: WARNING: %s #%d (%s,%ld) "
+		    "didn't exit in 5 seconds\n",
+		    hlp->id_name, no, hlp->cmdline->key, pid);
+	    }
+	    CloseHandle(hIpc);
+	}
+#endif
     }
 }
 
@@ -253,17 +274,14 @@
     assert(fd == srv->rfd);
     assert(cbdataValid(data));
     Counter.syscalls.sock.reads++;
-#ifdef _SQUID_MSWIN_
-    len = recv(fd, srv->buf + srv->offset, srv->buf_sz - srv->offset);
-#else
     len = read(fd, srv->buf + srv->offset, srv->buf_sz - srv->offset);
-#endif
     fd_bytes(fd, len, FD_READ);
     debug(29, 5) ("helperHandleRead: %d bytes from %s #%d.\n",
 	len, hlp->id_name, srv->index + 1);
     if (len <= 0) {
 	if (len < 0)
-	    debug(50, 1) ("helperHandleRead: FD %d read: %s\n", fd, xstrerror());
+	    debug(50, 1) ("helperHandleRead: FD %d read: %s\n", fd,
+		xstrerror());
 	comm_close(fd);
 	return;
     }
@@ -272,7 +290,8 @@
     r = srv->request;
     if (r == NULL) {
 	/* someone spoke without being spoken to */
-	debug(29, 1) ("helperHandleRead: unexpected read from %s #%d, %d bytes\n",
+	debug(29,
+	    1) ("helperHandleRead: unexpected read from %s #%d, %d bytes\n",
 	    hlp->id_name, srv->index + 1, len);
 	srv->offset = 0;
     } else if ((t = strchr(srv->buf, '\n'))) {
@@ -313,10 +332,13 @@
 	return;
     hlp->last_queue_warn = squid_curtime;
     debug(14, 0) ("WARNING: All %s processes are busy.\n", hlp->id_name);
-    debug(14, 0) ("WARNING: %d pending requests queued\n", hlp->stats.queue_size);
+    debug(14, 0) ("WARNING: %d pending requests queued\n",
+	hlp->stats.queue_size);
     if (hlp->stats.queue_size > hlp->n_running * 2)
 	fatalf("Too many queued %s requests", hlp->id_name);
-    debug(14, 1) ("Consider increasing the number of %s processes in your config file.\n", hlp->id_name);
+    debug(14, 1)
+	("Consider increasing the number of %s processes in your config file.\n",
+	hlp->id_name);
 }
 
 static helper_request *
@@ -364,16 +386,10 @@
     srv->flags.busy = 1;
     srv->request = r;
     srv->dispatch_time = current_time;
-    comm_write(srv->wfd,
-	r->buf,
-	strlen(r->buf),
-	NULL,			/* Handler */
+    comm_write(srv->wfd, r->buf, strlen(r->buf), NULL,	/* Handler */
 	NULL,			/* Handler-data */
 	NULL);			/* free */
-    commSetSelect(srv->rfd,
-	COMM_SELECT_READ,
-	helperHandleRead,
-	srv, 0);
+    commSetSelect(srv->rfd, COMM_SELECT_READ, helperHandleRead, srv, 0);
     debug(29, 5) ("helperDispatch: Request sent to %s #%d, %d bytes\n",
 	hlp->id_name, srv->index + 1, strlen(r->buf));
     srv->stats.uses++;
@@ -396,4 +412,4 @@
     xfree(r->buf);
     memFree(r, MEM_HELPER_REQUEST);
 }
-#endif// HELPER_C
+#endif // HELPER_C
Index: squid/src/htcp.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/htcp.c,v
retrieving revision 1.1.1.2.4.1.2.2
retrieving revision 1.1.1.2.4.1.2.2.2.1
diff -u -r1.1.1.2.4.1.2.2 -r1.1.1.2.4.1.2.2.2.1
--- squid/src/htcp.c	14 Jun 2001 21:34:24 -0000	1.1.1.2.4.1.2.2
+++ squid/src/htcp.c	27 Aug 2001 21:48:21 -0000	1.1.1.2.4.1.2.2.2.1
@@ -1,6 +1,5 @@
-
 /*
- * $Id: htcp.c,v 1.1.1.2.4.1.2.2 2001/06/14 21:34:24 serassio Exp $
+ * $Id: htcp.c,v 1.1.1.2.4.1.2.2.2.1 2001/08/27 21:48:21 tolsty Exp $
  *
  * DEBUG: section 31    Hypertext Caching Protocol
  * AUTHOR: Duane Wesssels
@@ -44,18 +43,21 @@
 typedef struct _htcpSpecifier htcpSpecifier;
 typedef struct _htcpDetail htcpDetail;
 
-struct _Countstr {
+struct _Countstr
+{
     u_short length;
     char *text;
 };
 
-struct _htcpHeader {
+struct _htcpHeader
+{
     u_short length;
     u_char major;
     u_char minor;
 };
 
-struct _htcpDataHeader {
+struct _htcpDataHeader
+{
     u_short length;
 #if !WORDS_BIGENDIAN
     unsigned int opcode:4;
@@ -81,7 +83,8 @@
     /* RR == 0 --> REQUEST */
     /* RR == 1 --> RESPONSE */
 
-struct _htcpAuthHeader {
+struct _htcpAuthHeader
+{
     u_short length;
     time_t sig_time;
     time_t sig_expire;
@@ -89,20 +92,23 @@
     Countstr signature;
 };
 
-struct _htcpSpecifier {
+struct _htcpSpecifier
+{
     char *method;
     char *uri;
     char *version;
     char *req_hdrs;
 };
 
-struct _htcpDetail {
+struct _htcpDetail
+{
     char *resp_hdrs;
     char *entity_hdrs;
     char *cache_hdrs;
 };
 
-struct _htcpStuff {
+struct _htcpStuff
+{
     int op;
     int rr;
     int f1;
@@ -112,7 +118,8 @@
     htcpDetail D;
 };
 
-enum {
+enum
+{
     HTCP_NOP,
     HTCP_TST,
     HTCP_MON,
@@ -121,8 +128,7 @@
     HTCP_END
 };
 
-static const char *const htcpOpcodeStr[] =
-{
+static const char *const htcpOpcodeStr[] = {
     "HTCP_NOP",
     "HTCP_TST",
     "HTCP_MON",
@@ -134,7 +140,8 @@
 /*
  * values for htcpDataHeader->response
  */
-enum {
+enum
+{
     AUTH_REQUIRED,
     AUTH_FAILURE,
     OPCODE_UNIMPLEMENTED,
@@ -146,7 +153,8 @@
 /*
  * values for htcpDataHeader->RR
  */
-enum {
+enum
+{
     RR_REQUEST,
     RR_RESPONSE
 };
@@ -172,15 +180,22 @@
 static void htcpFreeDetail(htcpDetail * s);
 static void htcpHandle(char *buf, int sz, struct sockaddr_in *from);
 static void htcpHandleData(char *buf, int sz, struct sockaddr_in *from);
-static void htcpHandleMon(htcpDataHeader *, char *buf, int sz, struct sockaddr_in *from);
-static void htcpHandleNop(htcpDataHeader *, char *buf, int sz, struct sockaddr_in *from);
-static void htcpHandleSet(htcpDataHeader *, char *buf, int sz, struct sockaddr_in *from);
-static void htcpHandleTst(htcpDataHeader *, char *buf, int sz, struct sockaddr_in *from);
+static void htcpHandleMon(htcpDataHeader *, char *buf, int sz,
+    struct sockaddr_in *from);
+static void htcpHandleNop(htcpDataHeader *, char *buf, int sz,
+    struct sockaddr_in *from);
+static void htcpHandleSet(htcpDataHeader *, char *buf, int sz,
+    struct sockaddr_in *from);
+static void htcpHandleTst(htcpDataHeader *, char *buf, int sz,
+    struct sockaddr_in *from);
 static void htcpRecv(int fd, void *data);
 static void htcpSend(const char *buf, int len, struct sockaddr_in *to);
-static void htcpTstReply(htcpDataHeader *, StoreEntry *, htcpSpecifier *, struct sockaddr_in *);
-static void htcpHandleTstRequest(htcpDataHeader *, char *buf, int sz, struct sockaddr_in *from);
-static void htcpHandleTstResponse(htcpDataHeader *, char *, int, struct sockaddr_in *);
+static void htcpTstReply(htcpDataHeader *, StoreEntry *, htcpSpecifier *,
+    struct sockaddr_in *);
+static void htcpHandleTstRequest(htcpDataHeader *, char *buf, int sz,
+    struct sockaddr_in *from);
+static void htcpHandleTstResponse(htcpDataHeader *, char *, int,
+    struct sockaddr_in *);
 static StoreEntry *htcpCheckHit(const htcpSpecifier *);
 
 static void
@@ -314,8 +329,7 @@
 htcpBuildOpData(char *buf, size_t buflen, htcpStuff * stuff)
 {
     ssize_t off = 0;
-    debug(31, 3) ("htcpBuildOpData: opcode %s\n",
-	htcpOpcodeStr[stuff->op]);
+    debug(31, 3) ("htcpBuildOpData: opcode %s\n", htcpOpcodeStr[stuff->op]);
     switch (stuff->op) {
     case HTCP_TST:
 	off = htcpBuildTstOpData(buf + off, buflen, stuff);
@@ -400,12 +414,10 @@
 	inet_ntoa(to->sin_addr), (int) ntohs(to->sin_port));
     htcpHexdump("htcpSend", buf, len);
     x = comm_udp_sendto(htcpOutSocket,
-	to,
-	sizeof(struct sockaddr_in),
-	buf,
-	len);
+	to, sizeof(struct sockaddr_in), buf, len);
     if (x < 0)
-	debug(31, 0) ("htcpSend: FD %d sendto: %s\n", htcpOutSocket, xstrerror());
+	debug(31, 0) ("htcpSend: FD %d sendto: %s\n", htcpOutSocket,
+	    xstrerror());
 }
 
 /*
@@ -535,7 +547,8 @@
 }
 
 static void
-htcpTstReply(htcpDataHeader * dhdr, StoreEntry * e, htcpSpecifier * spec, struct sockaddr_in *from)
+htcpTstReply(htcpDataHeader * dhdr, StoreEntry * e, htcpSpecifier * spec,
+    struct sockaddr_in *from)
 {
     htcpStuff stuff;
     char *pkt;
@@ -564,8 +577,7 @@
 	stuff.S.version = spec->version;
 	stuff.S.req_hdrs = spec->req_hdrs;
 	httpHeaderPutInt(&hdr, HDR_AGE,
-	    e->timestamp <= squid_curtime ?
-	    squid_curtime - e->timestamp : 0);
+	    e->timestamp <= squid_curtime ? squid_curtime - e->timestamp : 0);
 	httpHeaderPackInto(&hdr, &p);
 	stuff.D.resp_hdrs = xstrdup(mb.buf);
 	debug(31, 3) ("htcpTstReply: resp_hdrs = {%s}\n", stuff.D.resp_hdrs);
@@ -577,7 +589,8 @@
 	    httpHeaderPutTime(&hdr, HDR_LAST_MODIFIED, e->lastmod);
 	httpHeaderPackInto(&hdr, &p);
 	stuff.D.entity_hdrs = xstrdup(mb.buf);
-	debug(31, 3) ("htcpTstReply: entity_hdrs = {%s}\n", stuff.D.entity_hdrs);
+	debug(31, 3) ("htcpTstReply: entity_hdrs = {%s}\n",
+	    stuff.D.entity_hdrs);
 	memBufReset(&mb);
 	httpHeaderReset(&hdr);
 	if ((host = urlHostname(spec->uri))) {
@@ -655,7 +668,8 @@
 }
 
 static void
-htcpHandleTstResponse(htcpDataHeader * hdr, char *buf, int sz, struct sockaddr_in *from)
+htcpHandleTstResponse(htcpDataHeader * hdr, char *buf, int sz,
+    struct sockaddr_in *from)
 {
     htcpReplyData htcpReply;
     cache_key *key = NULL;
@@ -668,7 +682,8 @@
     memset(&htcpReply, '\0', sizeof(htcpReply));
     httpHeaderInit(&htcpReply.hdr, hoHtcpReply);
     htcpReply.msg_id = hdr->msg_id;
-    debug(31, 3) ("htcpHandleTstResponse: msg_id = %d\n", (int) htcpReply.msg_id);
+    debug(31, 3) ("htcpHandleTstResponse: msg_id = %d\n",
+	(int) htcpReply.msg_id);
     htcpReply.hit = hdr->response ? 0 : 1;
     if (hdr->F1) {
 	debug(31, 3) ("htcpHandleTstResponse: MISS\n");
@@ -687,7 +702,8 @@
 	    httpHeaderParse(&htcpReply.hdr, t, t + strlen(t));
     }
     key = queried_keys[htcpReply.msg_id % N_QUERIED_KEYS];
-    debug(31, 3) ("htcpHandleTstResponse: key (%p) %s\n", key, storeKeyText(key));
+    debug(31, 3) ("htcpHandleTstResponse: key (%p) %s\n", key,
+	storeKeyText(key));
     neighborsHtcpReply(key, &htcpReply, from);
     httpHeaderClean(&htcpReply.hdr);
     if (d)
@@ -695,7 +711,8 @@
 }
 
 static void
-htcpHandleTstRequest(htcpDataHeader * dhdr, char *buf, int sz, struct sockaddr_in *from)
+htcpHandleTstRequest(htcpDataHeader * dhdr, char *buf, int sz,
+    struct sockaddr_in *from)
 {
     /* buf should be a SPECIFIER */
     htcpSpecifier *s;
@@ -712,12 +729,10 @@
 	return;
     }
     debug(31, 3) ("htcpHandleTstRequest: %s %s %s\n",
-	s->method,
-	s->uri,
-	s->version);
+	s->method, s->uri, s->version);
     debug(31, 3) ("htcpHandleTstRequest: %s\n", s->req_hdrs);
     if ((e = htcpCheckHit(s)))
-	htcpTstReply(dhdr, e, s, from);		/* hit */
+	htcpTstReply(dhdr, e, s, from);	/* hit */
     else
 	htcpTstReply(dhdr, NULL, NULL, from);	/* cache miss */
     htcpFreeSpecifier(s);
@@ -740,7 +755,8 @@
 {
     htcpDataHeader hdr;
     if (sz < sizeof(htcpDataHeader)) {
-	debug(31, 0) ("htcpHandleData: msg size less than htcpDataHeader size\n");
+	debug(31,
+	    0) ("htcpHandleData: msg size less than htcpDataHeader size\n");
 	return;
     }
     xmemcpy(&hdr, buf, sizeof(htcpDataHeader));
@@ -840,16 +856,8 @@
 htcpInit(void)
 {
     enter_suid();
-    htcpInSocket = comm_open(SOCK_DGRAM,
-#ifdef _SQUID_MSWIN_
-	IPPROTO_UDP,
-#else
-	0,
-#endif
-	Config.Addrs.udp_incoming,
-	Config.Port.htcp,
-	COMM_NONBLOCKING,
-	"HTCP Socket");
+    htcpInSocket = comm_open(SOCK_DGRAM, 0, Config.Addrs.udp_incoming,
+	Config.Port.htcp, COMM_NONBLOCKING, "HTCP Socket");
     leave_suid();
     if (htcpInSocket < 0)
 	fatal("Cannot open HTCP Socket");
@@ -858,16 +866,8 @@
 	(int) Config.Port.htcp, htcpInSocket);
     if (Config.Addrs.udp_outgoing.s_addr != no_addr.s_addr) {
 	enter_suid();
-	htcpOutSocket = comm_open(SOCK_DGRAM,
-#ifdef _SQUID_MSWIN_
-	    IPPROTO_UDP,
-#else
-	    0,
-#endif
-	    Config.Addrs.udp_outgoing,
-	    Config.Port.htcp,
-	    COMM_NONBLOCKING,
-	    "Outgoing HTCP Socket");
+	htcpOutSocket = comm_open(SOCK_DGRAM, 0, Config.Addrs.udp_outgoing,
+	    Config.Port.htcp, COMM_NONBLOCKING, "Outgoing HTCP Socket");
 	leave_suid();
 	if (htcpOutSocket < 0)
 	    fatal("Cannot open Outgoing HTCP Socket");
Index: squid/src/http.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/http.c,v
retrieving revision 1.1.1.3.4.3.2.2
retrieving revision 1.1.1.3.4.3.2.2.2.1
diff -u -r1.1.1.3.4.3.2.2 -r1.1.1.3.4.3.2.2.2.1
--- squid/src/http.c	29 Jul 2001 09:10:28 -0000	1.1.1.3.4.3.2.2
+++ squid/src/http.c	27 Aug 2001 21:48:21 -0000	1.1.1.3.4.3.2.2.2.1
@@ -1,6 +1,5 @@
-
 /*
- * $Id: http.c,v 1.1.1.3.4.3.2.2 2001/07/29 09:10:28 serassio Exp $
+ * $Id: http.c,v 1.1.1.3.4.3.2.2.2.1 2001/08/27 21:48:21 tolsty Exp $
  *
  * DEBUG: section 11    Hypertext Transfer Protocol (HTTP)
  * AUTHOR: Harvest Derived
@@ -335,7 +334,9 @@
     strncat(httpState->reply_hdr, buf, room < size ? room : size);
     hdr_len += room < size ? room : size;
     if (hdr_len > 4 && strncmp(httpState->reply_hdr, "HTTP/", 5)) {
-	debug(11, 3) ("httpProcessReplyHeader: Non-HTTP-compliant header: '%s'\n", httpState->reply_hdr);
+	debug(11,
+	    3) ("httpProcessReplyHeader: Non-HTTP-compliant header: '%s'\n",
+	    httpState->reply_hdr);
 	httpState->reply_hdr_state += 2;
 	reply->sline.status = HTTP_INVALID_HEADER;
 	return;
@@ -360,7 +361,8 @@
     httpReplyParse(reply, httpState->reply_hdr, hdr_len);
     storeTimestampsSet(entry);
     /* Check if object is cacheable or not based on reply code */
-    debug(11, 3) ("httpProcessReplyHeader: HTTP CODE: %d\n", reply->sline.status);
+    debug(11, 3) ("httpProcessReplyHeader: HTTP CODE: %d\n",
+	reply->sline.status);
     if (neighbors_do_private_keys)
 	httpMaybeRemovePublic(entry, reply->sline.status);
     switch (httpCachableReply(httpState)) {
@@ -479,12 +481,7 @@
     read_sz = delayBytesWanted(delay_id, 1, read_sz);
 #endif
     Counter.syscalls.sock.reads++;
-#ifdef _SQUID_MSWIN_
-    len = recv(fd, buf, read_sz);
-    errno = WSAGetLastError();
-#else
     len = read(fd, buf, read_sz);
-#endif
     debug(11, 5) ("httpReadReply: FD %d: len %d.\n", fd, len);
     if (len > 0) {
 	fd_bytes(fd, len, FD_READ);
@@ -511,11 +508,7 @@
     }
     if (len < 0) {
 	debug(50, 2) ("httpReadReply: FD %d: read failure: %s.\n",
-#ifdef _SQUID_MSWIN_
 	    fd, xstrerror());
-#else
-	    fd, wsastrerror(errno));
-#endif
 	if (ignoreErrno(errno)) {
 	    commSetSelect(fd, COMM_SELECT_READ, httpReadReply, httpState, 0);
 	} else if (entry->mem_obj->inmem_hi == 0) {
@@ -637,10 +630,7 @@
 void
 httpBuildRequestHeader(request_t * request,
     request_t * orig_request,
-    StoreEntry * entry,
-    HttpHeader * hdr_out,
-    int cfd,
-    http_state_flags flags)
+    StoreEntry * entry, HttpHeader * hdr_out, int cfd, http_state_flags flags)
 {
     /* building buffer for complex strings */
 #define BBUF_SZ (MAX_URL+32)
@@ -666,8 +656,15 @@
      *  the server and fetch only the requested content) 
      */
     we_do_ranges =
-	orig_request->range && orig_request->flags.cachable && !httpHdrRangeWillBeComplex(orig_request->range) && (Config.rangeOffsetLimit == -1 || httpHdrRangeFirstOffset(orig_request->range) <= Config.rangeOffsetLimit);
-    debug(11, 8) ("httpBuildRequestHeader: range specs: %p, cachable: %d; we_do_ranges: %d\n",
+	orig_request->range && orig_request->flags.cachable
+	&& !httpHdrRangeWillBeComplex(orig_request->range)
+	&& (Config.rangeOffsetLimit == -1
+	|| httpHdrRangeFirstOffset(orig_request->range) <=
+	Config.rangeOffsetLimit);
+    debug(11, 8)
+
+	
+	("httpBuildRequestHeader: range specs: %p, cachable: %d; we_do_ranges: %d\n",
 	orig_request->range, orig_request->flags.cachable, we_do_ranges);
 
     strConnection = httpHeaderGetList(hdr_in, HDR_CONNECTION);
@@ -784,7 +781,8 @@
 	if (!cc)
 	    cc = httpHdrCcCreate();
 	if (!EBIT_TEST(cc->mask, CC_MAX_AGE)) {
-	    const char *url = entry ? storeUrl(entry) : urlCanonical(orig_request);
+	    const char *url =
+		entry ? storeUrl(entry) : urlCanonical(orig_request);
 	    httpHdrCcSetMaxAge(cc, getMaxAge(url));
 	    if (strLen(request->urlpath))
 		assert(strstr(url, strBuf(request->urlpath)));
@@ -809,11 +807,8 @@
  * return the length of the prefix */
 mb_size_t
 httpBuildRequestPrefix(request_t * request,
-    request_t * orig_request,
-    StoreEntry * entry,
-    MemBuf * mb,
-    int cfd,
-    http_state_flags flags)
+request_t * orig_request,
+StoreEntry * entry, MemBuf * mb, int cfd, http_state_flags flags)
 {
     const int offset = mb->size;
     memBufPrintf(mb, "%s %s HTTP/1.0\r\n",
@@ -844,7 +839,8 @@
     peer *p = httpState->peer;
     CWCB *sendHeaderDone;
 
-    debug(11, 5) ("httpSendRequest: FD %d: httpState %p.\n", httpState->fd, httpState);
+    debug(11, 5) ("httpSendRequest: FD %d: httpState %p.\n", httpState->fd,
+	httpState);
 
     if (httpState->orig_request->content_length > 0)
 	sendHeaderDone = httpSendRequestEntry;
@@ -873,18 +869,15 @@
 	httpState->flags.keepalive = 1;
     else if (p->stats.n_keepalives_sent < 10)
 	httpState->flags.keepalive = 1;
-    else if ((double) p->stats.n_keepalives_recv / (double) p->stats.n_keepalives_sent > 0.50)
+    else if ((double) p->stats.n_keepalives_recv /
+	(double) p->stats.n_keepalives_sent > 0.50)
 	httpState->flags.keepalive = 1;
     if (httpState->peer)
 	if (neighborType(httpState->peer, httpState->request) == PEER_SIBLING)
 	    httpState->flags.only_if_cached = 1;
     memBufDefInit(&mb);
     httpBuildRequestPrefix(req,
-	httpState->orig_request,
-	entry,
-	&mb,
-	cfd,
-	httpState->flags);
+	httpState->orig_request, entry, &mb, cfd, httpState->flags);
     debug(11, 6) ("httpSendRequest: FD %d:\n%s\n", httpState->fd, mb.buf);
     comm_write_mbuf(httpState->fd, mb, sendHeaderDone, httpState);
 }
@@ -897,8 +890,7 @@
     request_t *proxy_req;
     request_t *orig_req = fwd->request;
     debug(11, 3) ("httpStart: \"%s %s\"\n",
-	RequestMethodStr[orig_req->method],
-	storeUrl(fwd->entry));
+	RequestMethodStr[orig_req->method], storeUrl(fwd->entry));
     cbdataAdd(httpState, memFree, MEM_HTTP_STATE_DATA);
     storeLockObject(fwd->entry);
     httpState->fwd = fwd;
@@ -947,7 +939,8 @@
 }
 
 static void
-httpSendRequestEntry(int fd, char *bufnotused, size_t size, int errflag, void *data)
+httpSendRequestEntry(int fd, char *bufnotused, size_t size, int errflag,
+    void *data)
 {
     HttpStateData *httpState = data;
     StoreEntry *entry = httpState->entry;
@@ -977,7 +970,8 @@
 }
 
 static void
-httpSendRequestEntryDone(int fd, char *bufnotused, size_t size, int errflag, void *data)
+httpSendRequestEntryDone(int fd, char *bufnotused, size_t size, int errflag,
+    void *data)
 {
     HttpStateData *httpState = data;
     StoreEntry *entry = httpState->entry;
@@ -1013,4 +1007,4 @@
 	comm_write(fd, "\r\n", 2, httpSendComplete, data, NULL);
     }
 }
-#endif //HTTP_C
\ No newline at end of file
+#endif /// HTTP_C
Index: squid/src/icmp.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/icmp.c,v
retrieving revision 1.1.1.2.4.2.2.1
retrieving revision 1.1.1.2.4.2.2.1.2.1
diff -u -r1.1.1.2.4.2.2.1 -r1.1.1.2.4.2.2.1.2.1
--- squid/src/icmp.c	6 Jan 2001 12:40:14 -0000	1.1.1.2.4.2.2.1
+++ squid/src/icmp.c	27 Aug 2001 21:48:21 -0000	1.1.1.2.4.2.2.1.2.1
@@ -1,6 +1,5 @@
-
 /*
- * $Id: icmp.c,v 1.1.1.2.4.2.2.1 2001/01/06 12:40:14 hno Exp $
+ * $Id: icmp.c,v 1.1.1.2.4.2.2.1.2.1 2001/08/27 21:48:21 tolsty Exp $
  *
  * DEBUG: section 37    ICMP Routines
  * AUTHOR: Duane Wessels
@@ -47,7 +46,13 @@
 static PF icmpRecv;
 static void icmpSend(pingerEchoData * pkt, int len);
 #if ALLOW_SOURCE_PING
-static void icmpHandleSourcePing(const struct sockaddr_in *from, const char *buf);
+static void icmpHandleSourcePing(const struct sockaddr_in *from,
+    const char *buf);
+#endif
+
+#ifdef _SQUID_MSWIN_
+static HANDLE hIpc;
+static pid_t pid;
 #endif
 
 static void
@@ -74,10 +79,7 @@
     commSetSelect(icmp_sock, COMM_SELECT_READ, icmpRecv, NULL, 0);
     memset(&preply, '\0', sizeof(pingerReplyData));
     Counter.syscalls.sock.recvfroms++;
-    n = recv(icmp_sock,
-	(char *) &preply,
-	sizeof(pingerReplyData),
-	0);
+    n = recv(icmp_sock, (char *) &preply, sizeof(pingerReplyData), 0);
     if (n < 0) {
 	debug(50, 1) ("icmpRecv: recv: %s\n", xstrerror());
 	if (++fail_count == 10 || errno == ECONNREFUSED)
@@ -197,18 +199,18 @@
     args[0] = "(pinger)";
     args[1] = NULL;
     x = ipcCreate(IPC_UDP_SOCKET,
-	Config.Program.pinger,
-	args,
-	"Pinger Socket",
-	&rfd,
-	&wfd);
+	Config.Program.pinger, args, "Pinger Socket", &rfd, &wfd
+#ifdef _SQUID_MSWIN_
+	, &hIpc, &pid
+#endif
+	);
     if (x < 0)
 	return;
     assert(rfd == wfd);
     icmp_sock = rfd;
     commSetSelect(icmp_sock, COMM_SELECT_READ, icmpRecv, NULL, 0);
     commSetTimeout(icmp_sock, -1, NULL, NULL);
-    debug(29, 1) ("Pinger socket opened on FD %d\n", icmp_sock);
+    debug(37, 1) ("Pinger socket opened on FD %d\n", icmp_sock);
 #endif
 }
 
@@ -218,9 +220,23 @@
 #if USE_ICMP
     if (icmp_sock < 0)
 	return;
-    debug(29, 1) ("Closing Pinger socket on FD %d\n", icmp_sock);
+    debug(37, 1) ("Closing Pinger socket on FD %d\n", icmp_sock);
+#ifdef _SQUID_MSWIN_
+    send(icmp_sock, "$shutdown\n", 10, 0);
+#endif
     comm_close(icmp_sock);
+#ifdef _SQUID_MSWIN_
+    if (hIpc) {
+	if (WaitForSingleObject(hIpc, 12000) != WAIT_OBJECT_0) {
+	    getCurrentTime();
+	    debug(34, 1)
+		("icmpClose: WARNING: (pinger,%ld) didn't exit in 12 seconds\n",
+		pid);
+	}
+	CloseHandle(hIpc);
+    }
+#endif
     icmp_sock = -1;
 #endif
 }
-#undef ICMP_C
\ No newline at end of file
+#undef ICMP_C
